package com.jiuqi.syntax;

import java.util.ArrayList;

public final class Niporlan implements Cloneable
{
    public static int NP_NEW_COUNT;
    public static int NP_LIVE_COUNT;
    public ArrayList ifItems;
    public ArrayList thenItems;
    public ArrayList elseItems;
    
    static {
        Niporlan.NP_NEW_COUNT = 0;
        Niporlan.NP_LIVE_COUNT = 0;
    }
    
    public Niporlan() {
        ++Niporlan.NP_NEW_COUNT;
        ++Niporlan.NP_LIVE_COUNT;
        this.thenItems = new ArrayList(5);
    }
    
    @Override
    protected void finalize() throws Throwable {
        --Niporlan.NP_LIVE_COUNT;
        super.finalize();
    }
    
    public ArrayList getIfItems() {
        return this.ifItems;
    }
    
    public ArrayList getThenItems() {
        return this.thenItems;
    }
    
    public ArrayList getElseItems() {
        return this.elseItems;
    }
    
    public boolean isEmpty() {
        return (this.ifItems == null || this.ifItems.isEmpty()) && this.thenItems.isEmpty() && (this.elseItems == null || this.elseItems.isEmpty());
    }
    
    public boolean isBalance() {
        if (this.elseExist()) {
            final NiporlanItem item = this.thenItems.get(this.thenItems.size() - 1);
            if (item.getType() == 0 && item.getOp() == 7) {
                final NiporlanItem item2 = this.elseItems.get(this.elseItems.size() - 1);
                return item2.getType() == 0 && item2.getOp() == 7;
            }
            return false;
        }
        else {
            if (this.thenItems.size() > 0) {
                final NiporlanItem item = this.thenItems.get(this.thenItems.size() - 1);
                return item.getType() == 0 && item.getOp() == 7;
            }
            return false;
        }
    }
    
    public Niporlan transBalanceToMinus() {
        final Niporlan minusNiporlan = (Niporlan)this.clone();
        if (minusNiporlan.elseExist()) {
            final NiporlanItem item = minusNiporlan.thenItems.get(minusNiporlan.thenItems.size() - 1);
            if (item.getType() == 0 && item.getOp() == 7) {
                item.setOp(2);
                final NiporlanItem item2 = minusNiporlan.elseItems.get(minusNiporlan.elseItems.size() - 1);
                if (item2.getType() == 0 && item2.getOp() == 7) {
                    item2.setOp(2);
                }
            }
        }
        else {
            final NiporlanItem item = minusNiporlan.thenItems.get(this.thenItems.size() - 1);
            if (item.getType() == 0 && item.getOp() == 7) {
                item.setOp(2);
            }
        }
        return minusNiporlan;
    }
    
    public boolean isOneCell() {
        if (this.ifExist()) {
            return false;
        }
        if (this.thenItems.size() != 1) {
            return false;
        }
        final NiporlanItem item = this.thenItems.get(0);
        return item.getType() == 3;
    }
    
    public DataCell getFirstCell() {
        for (int i = 0; this.ifItems != null && i < this.ifItems.size(); ++i) {
            final NiporlanItem item = this.ifItems.get(i);
            if (item.getType() == 3) {
                return item.getDataCell();
            }
        }
        for (int i = 0; i < this.thenItems.size(); ++i) {
            final NiporlanItem item = this.thenItems.get(i);
            if (item.getType() == 3) {
                return item.getDataCell();
            }
        }
        for (int i = 0; this.elseItems != null && i < this.elseItems.size(); ++i) {
            final NiporlanItem item = this.elseItems.get(i);
            if (item.getType() == 3) {
                return item.getDataCell();
            }
        }
        return null;
    }
    
    public boolean ifExist() {
        return this.ifItems != null && this.ifItems.size() > 0;
    }
    
    public boolean elseExist() {
        return this.elseItems != null && this.elseItems.size() > 0;
    }
    
    public void clear() {
        if (this.ifItems != null) {
            this.ifItems.clear();
        }
        this.thenItems.clear();
        if (this.elseItems != null) {
            this.elseItems.clear();
        }
    }
    
    @Override
    public String toString() {
        return "";
    }
    
    public void addIfItem(final NiporlanItem ni) {
        if (this.ifItems == null) {
            this.ifItems = new ArrayList(3);
        }
        this.ifItems.add(ni);
    }
    
    public void addIfItem(final int op) {
        if (this.ifItems == null) {
            this.ifItems = new ArrayList(3);
        }
        this.ifItems.add(new NiporlanItem(op));
    }
    
    public void addIfItem(final String funcName) {
        if (this.ifItems == null) {
            this.ifItems = new ArrayList(3);
        }
        this.ifItems.add(new NiporlanItem(funcName));
    }
    
    public void addIfItem(final CommonData commonData) {
        if (this.ifItems == null) {
            this.ifItems = new ArrayList(3);
        }
        this.ifItems.add(new NiporlanItem(commonData));
    }
    
    public void addIfItem(final DataCell dataCell) {
        if (this.ifItems == null) {
            this.ifItems = new ArrayList(3);
        }
        this.ifItems.add(new NiporlanItem(dataCell));
    }
    
    public void addIfItem(final Object object) {
        if (this.ifItems == null) {
            this.ifItems = new ArrayList(3);
        }
        this.ifItems.add(new NiporlanItem(object));
    }
    
    public void addThenItem(final NiporlanItem ni) {
        this.thenItems.add(ni);
    }
    
    public void addThenItem(final int op) {
        this.thenItems.add(new NiporlanItem(op));
    }
    
    public void addThenItem(final String funcName) {
        this.thenItems.add(new NiporlanItem(funcName));
    }
    
    public void addThenItem(final CommonData commonData) {
        this.thenItems.add(new NiporlanItem(commonData));
    }
    
    public void addThenItem(final DataCell dataCell) {
        this.thenItems.add(new NiporlanItem(dataCell));
    }
    
    public void addThenItem(final Object object) {
        this.thenItems.add(new NiporlanItem(object));
    }
    
    public void addElseitem(final NiporlanItem ni) {
        if (this.elseItems == null) {
            this.elseItems = new ArrayList(5);
        }
        this.elseItems.add(ni);
    }
    
    public void addElseItem(final int op) {
        if (this.elseItems == null) {
            this.elseItems = new ArrayList(5);
        }
        this.elseItems.add(new NiporlanItem(op));
    }
    
    public void addElseItem(final String funcName) {
        if (this.elseItems == null) {
            this.elseItems = new ArrayList(5);
        }
        this.elseItems.add(new NiporlanItem(funcName));
    }
    
    public void addElseItem(final CommonData commonData) {
        if (this.elseItems == null) {
            this.elseItems = new ArrayList(5);
        }
        this.elseItems.add(new NiporlanItem(commonData));
    }
    
    public void addElseItem(final DataCell dataCell) {
        if (this.elseItems == null) {
            this.elseItems = new ArrayList(5);
        }
        this.elseItems.add(new NiporlanItem(dataCell));
    }
    
    public void addElseItem(final Object object) {
        if (this.elseItems == null) {
            this.elseItems = new ArrayList(5);
        }
        this.elseItems.add(new NiporlanItem(object));
    }
    
    public Object clone() {
        final Niporlan newNiporlan = new Niporlan();
        for (int i = 0; this.ifItems != null && i < this.ifItems.size(); ++i) {
            final NiporlanItem item = new NiporlanItem();
            item.assign(this.ifItems.get(i));
            newNiporlan.getIfItems().add(item);
        }
        for (int i = 0; i < this.thenItems.size(); ++i) {
            final NiporlanItem item = new NiporlanItem();
            item.assign(this.thenItems.get(i));
            newNiporlan.getThenItems().add(item);
        }
        for (int i = 0; this.elseItems != null && i < this.elseItems.size(); ++i) {
            final NiporlanItem item = new NiporlanItem();
            item.assign(this.elseItems.get(i));
            newNiporlan.getElseItems().add(item);
        }
        return newNiporlan;
    }
}
